/*
 * TableJPanel.java
 * Tomokazu ARITA
 * arita@r.dendai.ac.jp
 * Created on 2003/11/18, 0:25
 */

package org.hichart.h3code.gui;

import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Color;


public class TableJPanel extends JPanel implements HasTarget{
    
    /**
	 * serialVersionUID: Automatic Generated ID
	 */
	private static final long serialVersionUID = -6347066007321422850L;
	
	
	private org.hichart.h3code.Table table; //݂̃e[u
    private TargetManager manager; //^[QbgǗ
    
    
    /** RXgN^ */
    public TableJPanel(){
        init();
    }
    
    private void init(){
        setLayout(null);
        setBackground(Color.white);
    }
    
    //e[ũZbg
    public void setTable(org.hichart.h3code.Table table){
        this.table = table;
    }
    
    /* R|[lg̕` */
    public void paintComponent(Graphics g){
        super.paintComponent(g);//
        if(getSize().width <= 0 || getSize().height <= 0){ return; }//܂TCY肵ĂȂ
        Graphics2D g2 = (Graphics2D) g;
        
        if (isShowing()) {
            /* e[u̕` */
             paintTable(g2);
        }
    }
    
    /* e[u̕` */
    /* publicɕύX */
    public void paintTable(Graphics2D g2){
        if(table == null){ return; }//e[uȂȂΏI
        
        /* e[u` */
        TableDrawer td = new TableDrawer(); //ǉ
        td.draw(g2, table, manager); //ǉ
    }
    
    //HasTaraget\bh
    public TargetManager getTargetManager() {
        return manager;
    }
    
    //HasTaraget\bh
    public void setTargetManager(TargetManager manager) {
        this.manager = manager;
    }
    
}
