package testclasses;

/**
 * H3CodeViewer
 * @author Tomokazu ARITA
 * @version 0.1.0
 * @date 2005/11/27
 */


/*
 * Created on 2005/01/09 (H3Code)
 * Tomokazu ARITA
 * arita@obirin.ac.jp
 * up 050308
 * up 050711
 * up 050914
 * up 051127
 */

/**
 * @author Tomokazu ARITA (arita@obirin.ac.jp)
 * 2005/01/09 23:41:10 
 * update 2005/09/14 
 *
 */



import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JPanel;

import org.hichart.h3code.Table;
import org.hichart.h3code.tool.H3CFileLoader;
import org.hichart.h3code.gui.TableJPanel;
import org.hichart.h3code.gui.TableEventAdapter;
import org.hichart.h3code.gui.TargetManager;






public class H3CodeViewer extends JFrame {
	
	
    /**
	 * serialVersionUID: Automatic generated ID by Eclipse
	 */
	private static final long serialVersionUID = -7344905929987644583L;


	/* Fields */
	Table table = null;
	
	
	/* Window Property */
	private static String frameTitle = "H3CodeViewer 0.1.0"; 
	private static int FRAME_WIDTH  = 800;
	private static int FRAME_HEIGHT = 600;
	
	
	//GUI
	private static final JPanel mainPanel = new JPanel(); //Frame̒Spl
    private static final TableJPanel tableView = new TableJPanel();
    //private static final JPanel htcPanel = new JPanel();
    //private static final JPanel hccPanel = new JPanel();
    
    //private static final JPanel htcButtonPanel = new JPanel();
    private static final JMenuBar menu_bar = new JMenuBar();
    

    
    //EventListener
    private TableEventAdapter table_event = null;
    private TargetManager target_manager = new TargetManager(151);
	
	
	/* File Loader */
    H3CFileLoader fileLoader;
	
    //
    private H3CCommandMenu command_menu;
	
	
	/* RXgN^ */
	public H3CodeViewer(){ 
		initFrame(); //t[̏
		initContentPane();//R|[lg̏
		initMenu(); // j[̏
		
		
		this.setTable(null); //050711 BUG FIX
	}
	
	
	/* t[̏ */
	private void initFrame(){
		
		/* ^Cgo[̐ݒ */
		this.setTitle(frameTitle);
		
		/* t[TCY̐ݒ */
		this.setSize(FRAME_WIDTH, FRAME_HEIGHT);
		
		/* N[Y{bNX̐ݒ */
		this.setDefaultCloseOperation(HIDE_ON_CLOSE);
	}
		
	
	/* GUIݒ */
    private void initContentPane(){
        
        //event 2003/11/16
        table_event = new TableEventAdapter(tableView);//ǉ
        tableView.addMouseListener(table_event);
        tableView.setTargetManager(target_manager);//^[Qbgݒ
        table_event.setTargetManager(target_manager);//^[Qbgݒ
        
        //ǉ041214
        //c[o[
        mainPanel.setLayout(new BorderLayout());
        mainPanel.add(tableView, BorderLayout.CENTER);
        
        
        getContentPane().add(mainPanel);   
    }
    
    
    /* j[Zbg */
    private boolean firstF = true; /* 񂾂Ăяo 050711 BugFix */
    private void initMenu(){
    	if(firstF){
    		menu_bar.removeAll(); //050711 Bug Fix
    		
    		H3CMainFileMenu file_menu = new H3CMainFileMenu(this);
        	menu_bar.add(file_menu);
        	
        	//Command Menu
            command_menu = new H3CCommandMenu(table, target_manager, tableView);
        	menu_bar.add(command_menu);
        	
        	setJMenuBar(menu_bar);
        	firstF = false;
    	}
    }
    
    
    public void setTable(org.hichart.h3code.Table table){
        this.table = table;
        tableView.setTable(table);
        table_event.setTable(table); //2003/11/16 EVENT
        tableView.repaint();
        command_menu.setTable(table); //2005/01/29
        target_manager.removeALL(); //2005/02/15 (Bug)
    }
    
    //041217
    /** ݂̃e[uԂ */
    public org.hichart.h3code.Table getTable(){
        return table;
    }
    
    //050128
    /* ݂̕\`悵ĂplԂ */
	public TableJPanel getTableJPanel(){ return tableView; }
}

